--
-- Rubbish by Ludovicus (LuisOrtiz@Verizon.NET)
--
-- Merchant Sales Management Functions
--
-- This addon is dedidicated to Harry Wasylyk & Larry Hansen, the Canadian inventors of the disposable green polyethylene garbage bag.
local L = LibStub("AceLocale-3.0"):GetLocale("Rubbish")
--
-- Build up a list of things that are usable.
-- Sell unusable items first!
--


local L = LibStub("AceLocale-3.0"):GetLocale("Rubbish")
local UsableItemsForClass


local function RegisterClassUsable(class,...)
    if UsableItemsForClass[class] == nil then
        UsableItemsForClass[class] = {}
    end
    local last_item
	for n=1,select('#',...) do
		local item = select(n,...)
		if type(item) == "string" then
		    UsableItemsForClass[class][item]=true
		    last_item = item
		elseif type(item) == "numeric" then
		    UsableItemsForClass[class][last_item]=item
		end
	end
end


local function Init_UsableItemsForClass()
    UsableItemsForClass={}
    -- Armor and Shield
    RegisterClassUsable("WARRIOR","Plate",40,"Mail","Leather","Cloth","Shield")
    RegisterClassUsable("DEATHKNIGHT","Plate","Mail","Leather","Cloth")
    RegisterClassUsable("PALADIN","Plate",40,"Mail","Leather","Cloth","Shield")
    RegisterClassUsable("PRIEST","Cloth")
    RegisterClassUsable("SHAMAN","Mail",40,"Leather","Cloth","Shield")
    RegisterClassUsable("DRUID","Leather","Cloth")
    RegisterClassUsable("ROGUE","Leather","Cloth")
    RegisterClassUsable("HUNTER","Leather","Cloth")
    RegisterClassUsable("MAGE","Cloth")
    RegisterClassUsable("WARLOCK","Cloth")
    -- Weapons
    RegisterClassUsable("WARRIOR","One-Handed Axes","Two-Handed Axes", "One-Handed Swords" ,"Two-Handed Swords" , "One-Handed Maces" ,"Two-Handed Maces" , "Polearms", "Staves" , "Daggers", "Fist Weapons" , "Bows", "Crossbows", "Guns", "Thrown" )
    RegisterClassUsable("DEATHKNIGHT","One-Handed Axes","Two-Handed Axes", "One-Handed Swords" , "Two-Handed Swords" , "One-Handed Maces" ,"Two-Handed Maces" , "Polearms", "Relic" )
    RegisterClassUsable("PALADIN","One-Handed Axes","Two-Handed Axes", "One-Handed Swords" , "Two-Handed Swords" , "One-Handed Maces" ,"Two-Handed Maces" ,"Polearms", "Relic" )
    RegisterClassUsable("PRIEST","One-Handed Maces", "Staves", "Daggers", "Wands"  )
    RegisterClassUsable("SHAMAN","One-Handed Axes","Two-Handed Axes", "One-Handed Maces", "Two-Handed Maces" , "Polearms", "Staves" , "Daggers", "Fist Weapons", "Relic" )
    RegisterClassUsable("DRUID","One-Handed Maces" ,"Two-Handed Maces" , "Polearms", "Staves" , "Daggers", "Fist Weapons" , "Relic")
    RegisterClassUsable("ROGUE","One-Handed Axes", "One-Handed Swords" , "One-Handed Maces" , "Daggers", "Fist Weapons" , "Bows", "Crossbows", "Guns", "Thrown"  )
    RegisterClassUsable("HUNTER","One-Handed Axes","Two-Handed Axes", "One-Handed Swords" , "Two-Handed Swords" , "Polearms", "Staves", "Daggers", "Fist Weapons" , "Bows", "Crossbows", "Guns" )
    RegisterClassUsable("MAGE","One-Handed Swords" ,"Two-Handed Swords" , "Staves", "Daggers", "Wands" )
    RegisterClassUsable("WARLOCK","One-Handed Swords" ,"Two-Handed Swords" , "Staves", "Daggers", "Wands"  )


end


local function ItemUsableForClass(itemType,itemSubType)
    -- itemType,itemSubType from GetItemInfo(itemID)
    -- itemType is {"Armor", "Consumable", "Container", "Gem", "Key", "Miscellaneous", "Money", "Reagent", "Recipe", "Projectile", "Quest", "Quiver", "Trade Goods", "Weapon"}
    -- itemSubtype depends on itemType
    local name,nomen = UnitClass("player")
    if itemType == "Armor" then
        return UsableItemsForClass[nomen][itemSubtype] or false
    elseif itemType == "Weapon" then
        return UsableItemsForClass[nomen][itemSubtype] or false
    else
        return true
    end
end


--
-- Add a new tab to the Merchant frame
--
function Rubbish:AddMerchantTab()
	-- Be a little paranoid.  We want to add a tab, so we need to see how many there are!
	local tab = MerchantFrame.numTabs + 1
	Rubbish.SellTab = CreateFrame("Button","MerchantFrameTab"..tab,MerchantFrame,"CharacterFrameTabButtonTemplate",tab)
	_G["MerchantFrameTab"..tab] = Rubbish.SellTab
	Rubbish.SellTab:SetText(L["Sell"])
	Rubbish.SellTab:SetPoint("LEFT","MerchantFrameTab"..(tab-1),"RIGHT",-16,0)
	PanelTemplates_SetNumTabs(MerchantFrame, tab);
	-- Override the OnClick script for all the tabs so we can paginate cleanly
	for i=1, tab do
		local tabButton = _G["MerchantFrameTab"..i]
		tabButton:SetScript("OnClick", function()
			PanelTemplates_SetTab(MerchantFrame, i);
			Rubbish:MerchantFrame_Update();
		end);
	end
	Rubbish.SellTabIdx = tab
	Rubbish:RawHook("MerchantFrame_Update",true)
end


---
--- We need to override the default MerchantFrame_Update() function with our own to properly handle the new tab
---
function Rubbish:MerchantFrame_Update()
	if ( MerchantFrame.selectedTab == Rubbish.SellTabIdx) then
		-- Set the handlers for each button to our own
		if Rubbish.Orig_MerchantItem1ItemButton_OnEnter == nil then
			-- Save only once, in case the tab gets clicked more than once!
			Rubbish.Orig_MerchantItem1ItemButton_OnEnter = MerchantItem1ItemButton:GetScript("OnEnter")
			Rubbish.Orig_MerchantItem1ItemButton_OnClick = MerchantItem1ItemButton:GetScript("OnClick")
			Rubbish.Orig_MerchantItem1ItemButton_OnDragStart = MerchantItem1ItemButton:GetScript("OnDragStart")
			Rubbish:dprint("MerchantFrame_Update: cached _Orig")
		end
		for i=1, BUYBACK_ITEMS_PER_PAGE do
			local itemButton = _G["MerchantItem"..i.."ItemButton"];
			itemButton.UpdateTooltip = MerchantJunkItemButton_OnEnter
			itemButton:SetScript("OnEnter",MerchantJunkItemButton_OnEnter)
			itemButton:SetScript("OnClick",MerchantJunkItemButton_OnClick)
			itemButton:SetScript("OnDragStart",nil)			
		end	
		Rubbish:MerchantFrame_UpdateJunkInfo()
	else
		PanelTemplates_SetTab(MerchantFrame, MerchantFrame.selectedTab);
		local MFU = Rubbish.hooks["MerchantFrame_Update"]
		MFU()
	end
	
end


---
--- We need to override the default merchant item button OnEnter script with our own to properly handle the new tab
---
function MerchantJunkItemButton_OnEnter(button)
    if ( MerchantFrame.selectedTab == Rubbish.SellTabIdx) then
	    GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
	    GameTooltip:SetBagItem(button.bag,button.slot)
	    MerchantFrame.itemHover = button:GetID();
	    ShowBuybackSellCursor(button:GetID());
	else
	    Rubbish.Orig_MerchantItem1ItemButton_OnEnter(button)
	end
end


---
--- We need to override the default merchant item button OnClick script with our own to properly handle the new tab
---
function MerchantJunkItemButton_OnClick(self, button)
    if ( MerchantFrame.selectedTab == Rubbish.SellTabIdx) then
        if ( button == "LeftButton" ) then
            local itemID = GetContainerItemID(self.bag,self.slot)
            RubbishDB.NeverSell[itemID]=true
            Rubbish:say(L["Will never offer to sell:"],self.name)
            Rubbish:MerchantFrame_UpdateJunkInfo()
        else 
	        UseContainerItem(self.bag,self.slot)
	    end
	else
	    Rubbish.Orig_MerchantItem1ItemButton_OnClick(self,button)
	end
end




---
--- Use LibGratuity to read tooltips to determine if an item is soulbound
---
local Gratuity = LibStub("LibGratuity-3.0")
function Rubbish:IsSoulbound(bag,slot)
    Gratuity:SetBagItem(bag,slot)
    local SB = Gratuity:Find(ITEM_SOULBOUND)
    Rubbish:dprint("IsSoulbound",bag,slot,SB)
    return  SB
end
        


---
--- Determine if an item in a given (bag,slot) should be vendored.
---
--- 1) If the item is on the NeverSell list, do not sell it.
--- 2) If the item does not have a sell price (Hearthstone), do not sell it.
--- 3) If the item does not have a valid Rarity, do not sell it.
--- 4) At this point we assume the item will be sold.  Items are normally sold, cheapest first.
--- 5) If the item is soulbound, we discount it by 90%.
--- 6) If the item is not usable, we discount it by 90%.
--- 7) If Auctionator is present and we have not disabled the integration and ItemSuggest says to Vendor, we present it to be sold.
--- 8) If Auctionator is present and we have not disabled the integration and ItemSuggest says to not Vendor, we do not sell it.
--- 9) Otherwise, we present it to be sold!
---
function Rubbish:VendorOrNot(bag,slot)
	local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bag,slot);
	if texture == nil then return nil; end
	local itemID = GetContainerItemID(bag,slot)
	if RubbishDB.NeverSell[itemID] then
	    return nil
	end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID)
	if itemSellPrice == 0 then
	    return nil
	end
	if itemRarity < 0 then
		return nil;
	end


	local SB = Rubbish:IsSoulbound(bag,slot)
	local itemUsable = ItemUsableForClass(itemType,itemSubType)
	local suggestion = AucAdvanced and (not RubbishDB.noAucAdvanced) and AucAdvanced.Modules.Util.ItemSuggest.itemsuggest(itemLink,itemCount)
    local itemFactor = itemSellPrice


	if SB then
        itemFactor = itemFactor / 10
	end
	if not itemUsable then
	    itemFactor = itemFactor / 10
	end
	
	if (suggestion == "Vendor") then
		Rubbish:dprint("VendorOrNot AucAdvanced vendor",bag,slot,itemCount * itemSellPrice,itemName)
		return itemRarity, itemFactor , itemCount * itemSellPrice , itemName
	elseif suggestion ~= nil then
		Rubbish:dprint("VendorOrNot AucAdvanced reject",bag,slot,itemName)
		return nil
	end
	Rubbish:dprint("VendorOrNot offer",bag,slot,itemFactor, itemCount * itemSellPrice ,itemName,SB)
	return itemRarity, itemFactor , itemCount * itemSellPrice * (itemRarity+1) , itemName
end


local Rubbish_SortBySell
function Rubbish_SortBySell(a,b)
    return a[3] < b[3]
end


function Rubbish:GenerateSellList()
	local sell_list = {}
	local autoSold = 0
	for bag=BACKPACK_CONTAINER, NUM_BAG_SLOTS do
		local slots = GetContainerNumSlots(bag)
		if slots then
			for slot=1,slots do
				local itemRarity, itemFactor, itemPrice , itemName = Rubbish:VendorOrNot(bag,slot)
				if itemRarity then
					if itemRarity == 0 and RubbishDB["AlwaysSellJunk"] and RubbishDB["AutoSellLimit"] > autoSold then
					    Rubbish:say("Rubbish:GenerateSellList AlwaysSellJunk",bag,slot,itemName)
						UseContainerItem(bag,slot)
						autoSold = autoSold + 1
					else				
						table.insert(sell_list,{bag, slot, itemFactor, itemPrice, itemName})
					end
				end
			end
		end
	end
	table.sort(sell_list,Rubbish_SortBySell)
	return sell_list
end




function Rubbish:MerchantFrame_UpdateJunkInfo()
	MerchantNameText:SetText("Rubbish");
	MerchantFramePortrait:SetTexture("Interface\\AddOns\\Rubbish\\Rubbish");
	-- Position Junk items
	local sellItems = Rubbish:GenerateSellList()
	local numSellItems = #sellItems
	Rubbish:dprint("MerchantFrame_UpdateJunkInfo selling", numSellItems)
	for i=1, BUYBACK_ITEMS_PER_PAGE do
		local itemButton = _G["MerchantItem"..i.."ItemButton"];
		local buybackButton = _G["MerchantItem"..i];
		_G["MerchantItem"..i.."AltCurrencyFrame"]:Hide();
		if ( i <= numSellItems) then
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(sellItems[i][1],sellItems[i][2])
			local itemID = GetContainerItemID(sellItems[i][1],sellItems[i][2])
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemID)
			Rubbish:dprint("MerchantFrame_UpdateJunkInfo selling", i, sellItems[i][1],sellItems[i][2],sellItems[i][3],sellItems[i][4],sellItems[i][5])
			_G["MerchantItem"..i.."Name"]:SetText(itemName);
			SetItemButtonCount(itemButton, itemCount);
			SetItemButtonStock(itemButton, itemCount);
			SetItemButtonTexture(itemButton, itemTexture);


			_G["MerchantItem"..i.."MoneyFrame"]:Show();
			MoneyFrame_Update("MerchantItem"..i.."MoneyFrame", itemSellPrice*itemCount);
			itemButton:SetID(i);
--			itemButton.link = itemLink
--			itemButton.texture = itemTexture
			itemButton.bag = sellItems[i][1]
			itemButton.slot = sellItems[i][2]
			itemButton.name = sellItems[i][5]
			itemButton.UpdateTooltip = MerchantJunkItemButton_OnEnter
--			itemButton:UpdateTooltip()
			itemButton:Show();


			if (itemRarity == 0 ) then
				SetItemButtonDesaturated(buybackButton,1)
				SetItemButtonDesaturated(itemButton,1)
			else
				SetItemButtonNameFrameVertexColor(buybackButton, 0.5, 0.5, 0.5);
				SetItemButtonSlotVertexColor(buybackButton, 1.0, 1.0, 1.0);
				SetItemButtonTextureVertexColor(itemButton, 1.0, 1.0, 1.0);
				SetItemButtonNormalTextureVertexColor(itemButton, 1.0, 1.0, 1.0);
			end


		else
			SetItemButtonNameFrameVertexColor(buybackButton, 0.5, 0.5, 0.5);
			SetItemButtonSlotVertexColor(buybackButton,0.4, 0.4, 0.4);
			_G["MerchantItem"..i.."Name"]:SetText("");
			_G["MerchantItem"..i.."MoneyFrame"]:Hide();
			itemButton:Hide();
		end
	end	
	-- Hide all merchant related items
	MerchantRepairAllButton:Hide();
	MerchantRepairItemButton:Hide();
	MerchantBuyBackItem:Hide();
	MerchantPrevPageButton:Hide();
	MerchantNextPageButton:Hide();
	MerchantFrameBottomLeftBorder:Hide();
	MerchantFrameBottomRightBorder:Hide();
	MerchantRepairText:Hide();
	MerchantPageText:Hide();
	MerchantGuildBankRepairButton:Hide();
	
	-- Hide buyback related items
	MerchantItem11:Hide();
	MerchantItem12:Hide();
	BuybackFrameTopLeft:Hide();
	BuybackFrameTopRight:Hide();
	BuybackFrameBotLeft:Hide();
	BuybackFrameBotRight:Hide();
end




-- Initialize the Merchant interaction portion of Rubbish
-- We create a new pane on the merchant window
function Rubbish:Merchant_Init()
    Init_UsableItemsForClass()
	Rubbish:dprint("Rubbish:Merchant_Init()")
	Rubbish:RegisterEvent("MERCHANT_SHOW");
	Rubbish:AddMerchantTab()
	RubbishDB.NeverSell = RubbishDB.NeverSell or {}
end




function Rubbish:Merchant_Disable()
	Rubbish:dprint("Rubbish:Merchant_Disable()")
	Rubbish:UnregisterEvent("MERCHANT_SHOW");
end




function Rubbish:MERCHANT_SHOW(event)
	if RubbishDB["AlwaysSellJunk"] then
		Rubbish:GenerateSellList()
	end
end


